Chuyển đến nội dung
Diễn đàn CADViet

hawking312

Thành viên
  • Số lượng nội dung

    22
  • Đã tham gia

  • Lần ghé thăm cuối

Bài đăng được đăng bởi hawking312


  1. Vào lúc 9/6/2020 tại 10:50, thiep đã nói:
    
    ;;;   LISP convert ARC, CIRCLE, ELLIPSE, SPLINE to LWPOLYLINE
    ;;   By Trân Thiêp 0918.841230
    ;;       05/2020.
    (defun curve->Lstpo (ent num / LL_UR )
        (setq LL_UR (acet-ent-geomextents ent))
        (ACET-GEOM-SPLINE-POINT-LIST ent
                                     (/ (distance (car LL_UR) (cadr LL_UR)) num)
        )
    )
    (defun c:c2pl (/ ss lstpo obj col Ltype LtypeScale)
        (command "undo" "be")
        (acet-error-init '(("cmdecho" 0 "osmode" 0) 0))
        (or ucshold_thiep (setq ucshold_thiep (acet-ucs-get nil)))
        (acet-ucs-cmd '("w"))
        (PROMPT "\nSelect curves to convert it into Lwpolylines" )
        (while (NOT (setq ss (ssget '((0 . "ARC,CIRCLE,ELLIPSE,SPLINE")))))
            (PROMPT "\nSelect arn't right, please select curves again" )
        )
        (mapcar '(lambda (x)
                     (setq eng (entget x))
                     (cond ((wcmatch (acet-dxf 0 eng) "ARC,CIRCLE,ELLIPSE")
                            (acet-Lwpline-make (list (curve->Lstpo x 2020)))
                           )
                           (T (acet-Lwpline-make (list (curve->Lstpo x 3000))))
                     )
                     (setq obj (vlax-ename->vla-object (entlast)))
                     (if (setq Ltype (acet-dxf 6 eng)) (Vla-put-Linetype obj Linetype))
                     (if (setq LtypeScale (acet-dxf 48 eng)) (Vla-put-LinetypeScale obj LtypeScale))
                     (Vla-put-LinetypeGeneration obj :vlax-true)
                     (Vla-put-layer obj (acet-dxf 8 eng))
                     (if (setq col (acet-dxf 62 eng)) (Vla-put-color obj col))
                     (entdel x)
                 )
                (acet-ss-to-list ss)
        )
        (acet-ucs-set ucshold_thiep)
        (acet-error-restore)
        (command "undo" "en")
        (princ "\nOk")
        (princ) 
    )

    Thử lại xem bạn. Nhân tiện fix luôn 1 lỗi nhỏ về color của đối tượng.

    Cảm ơn bác Thiệp tuyệt vời nhé, ưng ý quá luôn, nay mới vào diễn đàn.


  2. Vào lúc 29/4/2020 tại 14:52, thiep đã nói:

    Lisp này mình mới vừa đăng cách nay gần 1 tháng, chịu khó tìm là có:

    
    ;;; lisp convert curve: ARC, CIRCLE, ELLIPSE, SPLINE to Lwpolyline
    ;;                  by Trân Thiêp  0918841230                              
    (defun DXF (code en) (cdr (assoc code (entget en))))
    
    (defun c:c2pl (/ ss lstpo obj)
        (command "undo" "be")
        (and (not ACET-GEOM-SPLINE-POINT-LIST)
             (findfile "acetutil.arx")
            (arxload (findfile "acetutil.arx") "Failed to Load Express Tools")
        )
        (defun curve->Lstpo (ent num / LL_UR)
            (setq LL_UR (acet-ent-geomextents ent))
            (ACET-GEOM-SPLINE-POINT-LIST ent
                                         (/ (distance (car LL_UR) (cadr LL_UR)) num)
            )
        )
        (acet-error-init '(("cmdecho" 0 "osmode" 0 "PLINEGEN" 1) 1 (acet-ui-status)))
        (acet-ui-status "\nSelect curves to convert it into Lwpolylines" "PROMPT")
        (while (NOT (setq ss (ssget '((0 . "ARC,CIRCLE,ELLIPSE,SPLINE")))))
            (acet-ui-status "\nSelect arn't right, please select curves again" "PROMPT")
        )
        (acet-ui-status)
        (mapcar '(lambda (x)
                     (cond ((wcmatch (acet-dxf 0 (entget x)) "ARC,CIRCLE,ELLIPSE")
                            (acet-Lwpline-make (list (curve->Lstpo x 2020)))
                           )
                           (T (acet-Lwpline-make (list (curve->Lstpo x 3000))))
                     )
                     (setq obj (vlax-ename->vla-object (entlast)))
                     (if (dxf 6 x)(Vla-put-Linetype obj (dxf 6 x)))
                     (if (dxf 48 x)
                         (Vla-put-LinetypeScale obj (dxf 48 x))
                     )
                     (Vla-put-LinetypeGeneration obj :vlax-true)
                     (Vla-put-layer obj (dxf 8 x))
                     (if (setq col (dxf 62 x))
                         (Vla-put-color obj col)
                         (Vla-put-color obj 256)
                     )
                     (entdel x)
                 )
                (acet-ss-to-list ss)
        )
        (acet-error-restore)
        (command "undo" "en")
        (princ "\nOk")
    )

     

    Cảm ơn bác đã giúp đỡ, có thể bỏ bảng thông báo này mà thay bằng dòng command phía dưới cho dễ chịu và tăng tốc hơn được không bác, xin cảm ơn bác nhiều.

    image.png.f10486f5badc49867bcb9adb520ce2fc.png


  3. Như tiêu đề ạ, em có việc muốn chuyển các đường cong hoặc hình tròn thành các đa giác. Em thấy có app tương tự của Autodesk nhưng có tính phí, mong các tiền bối giúp đỡ. 

    Link Autodesk:
    CIR2VECT – Circle to Vectored polygon

    ARCVECT – Arc, PolyArc and Circle Vectorizer

    Video ví dụ

    https://www.youtube.com/watch?v=JZJTSI2N66E


  4. 13 phút trước, Danh Cong đã nói:

    Ủa, Phân tích hình thứ 2 của bạn có 3 HCN.

    Trong đó có 2 HCN bên trên có nét viền ngoài sáng lên, HCN thứ 3 thì thể hiện Preview.   --> Bạn đã chọn được 2 HCN và chưa Pick HCN thứ 3. :)))

    Cad đã thể hiện thế rồi còn gì. Hay bạn còn muốn thế nào :)))

    Dạ lỗi em ghi chưa rõ ràng ạ. Hình thứ 2 là hình em mong muốn, hình 1 là  hiện tại em đang bị và cần cách khắc phục anh. Em đang dùng cad18.

    Nghĩa là hình 2 em chọn ô nào sẽ có preview ô đó, chọn xong vẽ có đường bao thể hiện bên ngoài, là cái em mong muốn.

    Hình 1 là em chọn ô cũng sẽ có preview, nhưng chọn xong thì không hiện đường bao, khi chọn nhiều hình em sẽ không biết ô nào đã chọn, ô nào chưa.


  5. 24 phút trước, Danh Cong đã nói:

    + Ở Cad đời mới thì việc lựa chọn vùng Hatch xong, thì viền ngoài của vùng Hatch được thể hiện "sáng lên". ( Hình 2 của bạn)

    + Với 1 số Cad đời cũ  ( Tôi dùng 2007 và 2012 ) thì viền ngoài của Hatch được thể hiện nét đứt.

    Tóm lại bạn cần tinh mắt 1 tí, là biết được vùng nào đã chọn :)) Tôi thấy ko mấy khó khăn .

    dạ cảm ơn anh đã phản hồi. 

    Nếu nó hiện "sáng lên" hay "nét đứt" như anh thì em đã ít nhất phân biệt được ra, nó "không" hiện hoặc có gì đó phân biệt anh ạ. Em dùng cả cad 07 và 18. Em tìm hiểu kỹ trước trên GG, kể cả tiếng việt và tiếng anh đều không có nên mới lên nhờ anh em diễn đàn ạ. Xin cảm ơn.


  6. Khoang cach 1 lan rai: 500

    Co quay doi tuong vuong goc voi duong dan khong: Khong/Cok

    Error:no function definition: COPYGIUA; error: An error has occurred inside the 
    *error* functionbad argument type: fixnump: "40"

     

     

    Lệnh RTD hay RDT khi đến chỗ chọn có quay vuông góc đối tượng không thì chọn Không đều bị lỗi, Có thì k sao, mong bác chủ sửa giúp @duy782006


  7. Xin chào các bác, mình có 2 lisp tính diện tích. Mong các bác giúp giùm chỉnh sửa cái lisp DTT khi mà chọn vùng để tính diện tích thì nó hiện vùng hatch để tiện theo dõi với được không ạ. Mình thích chọn ô tính diện tích xong rồi chọn điểm để ghi text luôn chứ không thích phải chọn text có sẵn luôn. Xin cảm ơn.

    TINH DIEN TICH VA GHI SO.LSP

    (DTT)_tinh dien tich_chon diem ghi text_chon vung chon object.lsp


  8. Xin chào các bác, các anh em trong diễn đàn. Như tiêu đề, em đã dùng phần mềm SpeedCAD 2.0 được anh ghost8.3 tổng hợp từ lâu, cũng như quen và thoải mái với phần mềm này, nhảy công ty nào em cũng dùng :D Hiện tại thì bây giờ có thời gian thì em bắt đầu tìm tòi nghiên cứu chỉnh sửa lại phần mềm này cho tiện theo cá nhân em nhất và cũng như là có một số lệnh, menu không dùng được, hoặc em muốn thêm Hatch, chỉnh sửa Hatch. Nhưng dạo một vòng diễn đàn và GG thì em vẫn hoang mang mà mông lung quá, vẫn chưa biết phải bắt đầu từ đâu và như thế nào. Em dùng cách thủ công là những menu nào không dùng được "Command: _tn Unknown command "TN".  Press F1 for help." thì em tìm lisp tương tự và chỉnh lệnh lại xong chép vào support. Kính mong các bác, các anh em am hiểu giúp đỡ với, em cảm ơn. Bản cad em hay dùng và thấy ổn định là CAD07 và hiện tại em đang dùng 2009, do máy nhà không mạnh và máy công ty đa phần cũng không đầu tư nhiều nên chỉ tới đây thôi. Hiện tại thì em đang thử tìm hiểu file .mnr nhưng mông lung quá. Em cảm ơn.

    Ý em là chỉnh sửa lại SpeedCAD, cập nhật lại lisp, Hatch, lệnh, sắp xếp lại menu... và đóng gói lại để tiện cài đặt cho các máy khác sau này cũng như chia sẻ ạ.

    Kính mong anh ghost, cũng như anh Tuệ, anh Duy hay các anh em có kinh nghiệm, chuyên môn giúp đỡ với ạ.


  9. 52 phút trước, nikizi đã nói:

    Tớ dùng speedcad 2.0 được khoảng 2 năm rồi gỡ bỏ, chỉ để lại bộ cài cho mục đích cài font :D Không phải vì bộ đó không hữu ích mà muốn tùy chỉnh theo cá nhân của mình. Bộ lisp của anh ghost dùng file *.vlx nên không tùy chỉnh cũng như một số lệnh cần nhưng không sử dụng theo ý mình được :D

    Tớ liệt kê những lệnh hay dùng và tìm lisp tương ứng trên diễn đàn vì chủ yếu lisp của anh ghost8.3 tổng hợp trên cadviet. Lisp nào cần thì chỉnh sửa theo ý của mình, tất cả đều là file *.lsp. Chỉ cần ném cái đường dẫn folder lisp đó vào đường dẫn support trong cad thì chiến hết, không phải lo cài đặt.

    Tớ cũng định ngâm cứu làm Menu nhưng nghĩ không cần thiết vì dùng lệnh tắt quen rồi, hehehe.

    P/s: tớ thấy giang hồ đồn cad 2009 hay lỗi font thì phải, cứ 2007 mà chiến <3 Chúc vui!

    Vâng, tình trạng y hệt, chỉ là công việc mình xen kẽ giám sát thiết kế, cũng như hay nhảy cty :D nên mình chưa thật sự nghiêm túc tìm hiểu để chỉnh sửa theo ý. Giờ có thời gian xíu thì tìm hiểu thì thấy mênh mang quá. Thấy các cao thủ bỏ bê lâu quá mà thật sự nếu có cập nhật thì sẽ rất hữu ích và tiện cho các anh em, các bạn sau này. Cập nhật 1 lần xài chục năm :D

     


  10. Xin chào các bác, các anh em trong diễn đàn. Như tiêu đề, em đã dùng phần mềm SpeedCAD 2.0 được anh ghost8.3 tổng hợp từ lâu, cũng như quen và thoải mái với phần mềm này, nhảy công ty nào em cũng dùng :D Hiện tại thì bây giờ có thời gian thì em bắt đầu tìm tòi nghiên cứu chỉnh sửa lại phần mềm này cho tiện theo cá nhân em nhất và cũng như là có một số lệnh, menu không dùng được, hoặc em muốn thêm Hatch, chỉnh sửa Hatch. Nhưng dạo một vòng diễn đàn và GG thì em vẫn hoang mang mà mông lung quá, vẫn chưa biết phải bắt đầu từ đâu và như thế nào. Em dùng cách thủ công là những menu nào không dùng được "Command: _tn Unknown command "TN".  Press F1 for help." thì em tìm lisp tương tự và chỉnh lệnh lại xong chép vào support. Kính mong các bác, các anh em am hiểu giúp đỡ với, em cảm ơn. Bản cad em hay dùng và thấy ổn định là CAD07 và hiện tại em đang dùng 2009, do máy nhà không mạnh và máy công ty đa phần cũng không đầu tư nhiều nên chỉ tới đây thôi. Hiện tại thì em đang thử tìm hiểu file .mnr nhưng mông lung quá. Em cảm ơn.

    Ý em là chỉnh sửa lại SpeedCAD, cập nhật lại lisp, Hatch, lệnh, sắp xếp lại menu... và đóng gói lại để tiện cài đặt cho các máy khác sau này cũng như chia sẻ ạ.


  11. Tình hình là em đang làm đồ án cao đẳng Thi công đập đất Ninh Vân này, và đang thắc mắc mấy cái tính diện tích trên CAD như: diện tích bình quân mặt nước hố móng hạ thấp /ngày đêm, diện tích hố móng, khối lượng đào,... Em lúc trước có học CAD nhưng ông thầy dạy CAD lại dạy bên cơ khí, toàn vẽ bu lông đai ốc 1.gif nên mấy cái bên này khó quá, lại quên nữa 1.gif . Xin mấy anh, mấy bác giúp giùm em cách tính nha, em xin cảm ơn .

    Dưới đây là link Mediafire ạ:

    http://www.mediafire.com/?fh8bb9qemdezi1d

     

    http://www.mediafire.com/?30i0015x6nu9gq3

     

    http://www.mediafire.com/?mm69mwhb6vxq7n7

     

    http://www.mediafire.com/?9szm135r88miz0v

     

×